import copy
import numpy as np


class OperationAssignment(object):
    """
    : Operation sequencing
    """

    def __init__(self, data, data2, machineAssignment, overview, job_n):
        """

        :param data:
        :param data2:
        :param machineAssignment:
        :param overview:
        :param job_n:
        """
        self.data = data
        self.data2 = data2
        self.overview = overview
        self.job_n = job_n
        self.machineAssignment = machineAssignment

    def mwr(self):
        """
        Most Work Remaining
        :return:
        """
        mach3 = copy.deepcopy(self.machineAssignment)
        seq = []
        for i in range(len(self.data2.keys())):

            proc = [(j, l, mach3[j - 1][l - 1 - (len(self.machineAssignment[j - 1]) - len(mach3[j - 1]))]) for j in
                    range(1, self.job_n + 1) for l in
                    range((len(self.machineAssignment[j - 1]) - len(mach3[j - 1]) + 1),
                          len(self.machineAssignment[j - 1]) + 1)]

            proc_times = [sum([self.data[x] for x in proc if x[0] == k]) for k in range(1, self.job_n+1)]

            ind = np.argmax(proc_times)

            seq.append(ind + 1)

            try:
                del mach3[ind][0]
            except IndexError:
                break

        return seq

    def mor(self):
        """
        Most Operations Remaining
        :return:
        """

        mach3 = copy.deepcopy(self.machineAssignment)
        seq = []
        for i in range(len(self.data2.keys())):

            proc = [(j, l, mach3[j - 1][l - 1 - (len(self.machineAssignment[j - 1]) - len(mach3[j - 1]))]) for j in
                    range(1, self.job_n + 1) for l in
                    range((len(self.machineAssignment[j - 1]) - len(mach3[j - 1]) + 1),
                          len(self.machineAssignment[j - 1]) + 1)]

            proc_n = [len([self.data[x] for x in proc if x[0] == k]) for k in range(1, self.job_n+1)]
            ind = np.argmax(proc_n)

            seq.append(ind + 1)

            try:
                del mach3[ind][0]
            except IndexError:
                break

        return seq

    def random(self):
        """
        Random
        :return:
        """

        temp1 = sorted(self.data2.keys())
        temp1 = np.random.permutation(temp1)
        temp1 = map(tuple, temp1)

        seq = []
        for i in temp1:
            seq.append(i[0])

        return seq
